#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <pwd.h>
#include <sys/types.h>

int main(int argc, char * argv[])
{
 struct passwd * passwd;
 if (argc != 3)
 {
  fprintf(stderr, "Usage: %s <user_name> <command>\n", argv[0]);
  return 1;
 }

 passwd = getpwnam(argv[1]);
 if (!passwd)
 {
  fprintf(stderr, "User %s not found\n", argv[1]);
  return 2;
 }

 if (passwd->pw_uid < 1000)
 {
  fprintf(stderr, "uid < 1000\n");
  return 3;
 }

 if (setgid(passwd->pw_gid) != 0)
 {
  perror("setgid() failed");
  return 4;
 }

 if (setuid(passwd->pw_gid) != 0)
 {
  perror("setuid() failed");
  return 5;
 }

 system(argv[2]);
 return 0;
}
